package com.juablaz.MyPlaces.Model.Entity;

import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.*;

@Entity
@Table(name = "place", uniqueConstraints =
@UniqueConstraint(columnNames = {"latitude", "longitude", "username_fk"}, name = "constraintLatLongUser"))
public class Place {

    @Id
    @GeneratedValue
    private Long id;

    private Double latitude;
    private Double longitude;
    private String title;
    private String snippet;

    @ManyToOne()
    @JoinColumn(name = "username_fk")
    @JsonIgnore
    private User user;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Double getLatitude() {
        return latitude;
    }

    public void setLatitude(Double latitude) {
        this.latitude = latitude;
    }

    public Double getLongitude() {
        return longitude;
    }

    public void setLongitude(Double longitude) {
        this.longitude = longitude;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getSnippet() {
        return snippet;
    }

    public void setSnippet(String snippet) {
        this.snippet = snippet;
    }

    public User getUser() {
        return user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    @Override
    public String toString() {
        return "Place{" +
                "id=" + id +
                ", latitude=" + latitude +
                ", longitude=" + longitude +
                ", title='" + title + '\'' +
                ", snippet='" + snippet + '\'' +
                ", user=" + user +
                '}';
    }
}
