package com.juablaz.MyPlaces.Model.Entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "shared_place")
public class SharedPlace {

    @Id
    @GeneratedValue
    private Long id;
    private Double latitude;
    private Double longitude;
    private String title;
    private String snippet;

    @JsonFormat(timezone = "Europe/Madrid")
    private Date date;


    @ManyToOne()
    @JoinColumn(name = "target_user_fk")
    @JsonIgnore
    private User targetUser;

    @ManyToOne()
    @JoinColumn(name = "user_sharing_fk")
    @JsonIgnore
    private User userSharing;

    @Transient
    private String username;

    public String getUsername() {
        return userSharing.getUsername();
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public User getTargetUser() {
        return targetUser;
    }

    public void setTargetUser(User targetUser) {
        this.targetUser = targetUser;
    }

    public User getUserSharing() {
        return userSharing;
    }

    public void setUserSharing(User userSharing) {
        this.userSharing = userSharing;
    }

    public Double getLatitude() {
        return latitude;
    }

    public void setLatitude(Double latitude) {
        this.latitude = latitude;
    }

    public Double getLongitude() {
        return longitude;
    }

    public void setLongitude(Double longitude) {
        this.longitude = longitude;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getSnippet() {
        return snippet;
    }

    public void setSnippet(String snippet) {
        this.snippet = snippet;
    }

    @Override
    public String toString() {
        return "SharedPlace{" +
                "id=" + id +
                ", latitude=" + latitude +
                ", longitude=" + longitude +
                ", title='" + title + '\'' +
                ", snippet='" + snippet + '\'' +
                ", targetUser=" + targetUser +
                ", userSharing=" + userSharing +
                '}';
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }
}
