package com.juablaz.MyPlaces.Service;

import com.juablaz.MyPlaces.Model.Entity.User;
import com.juablaz.MyPlaces.Repository.UserRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;


@Service("userService")
public class UserServiceImpl implements UserService {


    private static final Logger logger = LoggerFactory.getLogger(UserServiceImpl.class);
    private final UserRepository userRepository;

    public UserServiceImpl(UserRepository userRepository) {
        this.userRepository = userRepository;
    }

    @Override
    public void saveUser(User user) {
        userRepository.save(user);
    }

    @Override
    public boolean userExists(User user) {
        User userFound = userRepository.findByUsername(user.getUsername());
        if (userFound != null) {
            logger.info("[UserServiceImpl][userExists]"+userFound.toString());
        } else {
            logger.info("[UserServiceImpl][userExists] No encontrado usuario");
        }

        if (userFound != null && user.getUsername().equals(userFound.getUsername())) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public boolean validateUser(User user) {
        User userFound = userRepository.findByUsernameAndPassword(user.getUsername(), user.getPassword());


        if(userFound!=null){
            logger.info(user.getMyFirebaseToken());
            userFound.setMyFirebaseToken(user.getMyFirebaseToken());

            userRepository.save(userFound);
            return true;

        }else{
            return false;
        }
    }

    @Override
    public User getUserByUsername(String username) {
        return userRepository.findByUsername(username);
    }

    @Override
    public void updateToken(User user) {
        User userFound = userRepository.findByUsername(user.getUsername());

        if(userFound!=null) {
            logger.info(userFound.toString());
            userFound.setMyFirebaseToken(user.getMyFirebaseToken());

            userRepository.save(userFound);
        }
    }
}
