package com.juablaz.myplaces;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.design.widget.TextInputLayout;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.example.juancarlos.myplaces.R;
import com.juablaz.myplaces.Util.EditTextLinesLimiter;

public class EditPlaceActivity extends Activity {

    private TextInputLayout inputLayoutTitle;
    private String returnTitle, returnSnippet;
    TextView textCountSnippet;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_edit_place);

        final EditText title = findViewById(R.id.input_title);
        final EditText snippet = findViewById(R.id.input_descripcion);

        final String titleText = getIntent().getStringExtra("title");
        final String idText = getIntent().getStringExtra("id");
        final double idLong = getIntent().getDoubleExtra("longitude",0);
        final double idLat = getIntent().getDoubleExtra("latitude",0);
        final String snippetDirectionText = getIntent().getStringExtra("direction");

        Button boton = findViewById(R.id.save);
        inputLayoutTitle = findViewById(R.id.input_layout_title);

        title.setText(titleText);
        snippet.setText(snippetDirectionText.split("Dirección: ")[0].replaceAll("\n\n", ""));

        textCountSnippet = findViewById(R.id.textCountSnippet);

        int MAX_LINES_SNIPPET = 10;
        snippet.addTextChangedListener(new EditTextLinesLimiter(EditPlaceActivity.this, snippet, MAX_LINES_SNIPPET, textCountSnippet, "snippet"));
        int MAX_LINES_TITLE = 1;
        title.addTextChangedListener(new EditTextLinesLimiter(title, MAX_LINES_TITLE, "title"));

        boton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(final View view) {
                boolean canResume = true;

                if (title.getText().toString().isEmpty()) {
                    inputLayoutTitle.setError("Debe introducir un titulo.");
                    canResume = false;
                } else {
                    returnTitle = title.getText().toString();
                    inputLayoutTitle.setErrorEnabled(false);
                }

                if (snippet.getText().toString().isEmpty()) {
                    returnSnippet = "Dirección: " + snippetDirectionText.split("Dirección: ")[1];
                } else {
                    returnSnippet = snippet.getText().toString() + "\n\n" + "Dirección: " + snippetDirectionText.split("Dirección: ")[1];
                }

                if (canResume) {
                    Intent resultIntent = new Intent();

                    resultIntent.putExtra("snippet", returnSnippet);
                    resultIntent.putExtra("title", returnTitle);
                    resultIntent.putExtra("id", idText);

                    Log.i("latlon",idLat+",xD ,  " + idLong);


                    resultIntent.putExtra("idLong", idLong);
                    resultIntent.putExtra("idLat", idLat);

                    setResult(Activity.RESULT_OK, resultIntent);
                    finish();
                }

            }
        });
    }


}