package com.juablaz.myplaces;

import android.annotation.SuppressLint;
import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.drawable.Drawable;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.NonNull;
import android.support.design.widget.TextInputLayout;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.text.method.PasswordTransformationMethod;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.android.volley.Request;
import com.android.volley.RequestQueue;
import com.android.volley.Response;
import com.android.volley.VolleyError;
import com.android.volley.toolbox.JsonObjectRequest;
import com.android.volley.toolbox.Volley;
import com.example.juancarlos.myplaces.R;
import com.google.android.gms.common.ConnectionResult;
import com.google.android.gms.common.GoogleApiAvailability;
import com.google.android.gms.maps.model.Marker;
import com.google.android.gms.maps.model.MarkerOptions;
import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.iid.FirebaseInstanceId;
import com.google.firebase.iid.InstanceIdResult;
import com.juablaz.myplaces.Util.CustomResponse;
import com.juablaz.myplaces.model.CustomMarker;
import com.juablaz.myplaces.model.Usuario;

import org.json.JSONException;
import org.json.JSONObject;

import static com.juablaz.myplaces.Util.Constants.ERROR_DIALOG_REQUEST;
import static com.juablaz.myplaces.Util.Constants.PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION;
import static com.juablaz.myplaces.Util.Constants.PERMISSIONS_REQUEST_ENABLE_GPS;
import static com.juablaz.myplaces.Util.StringUtils.BAR;
import static com.juablaz.myplaces.Util.StringUtils.DOUBLE_BAR;
import static com.juablaz.myplaces.Util.StringUtils.HOST;
import static com.juablaz.myplaces.Util.StringUtils.LOGIN_KO;
import static com.juablaz.myplaces.Util.StringUtils.LOGIN_OK;
import static com.juablaz.myplaces.Util.StringUtils.PORT;
import static com.juablaz.myplaces.Util.StringUtils.PROTOCOL;
import static com.juablaz.myplaces.Util.StringUtils.RESPONSE_OK;
import static com.juablaz.myplaces.Util.StringUtils.STATE_2xx;
import static com.juablaz.myplaces.Util.StringUtils.TWO_POINTS;

public class LoginActivity extends AppCompatActivity implements Response.Listener<JSONObject>, Response.ErrorListener {

    private TextView userName;
    private TextView password;
    private Button login;
    private String token;
    //TODO: Handle userLogged.
    private Usuario userLogged;
    private static final String TAG = "LoginActivity";

    boolean mLocationPermissionGranted = false;

    private TextInputLayout inputLayoutUserName, inputLayoutPassword;


    @SuppressLint("ClickableViewAccessibility")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login);

        userName = findViewById(R.id.input_nombreUsuario);
        password = findViewById(R.id.input_contrasena);
        login = findViewById(R.id.btn_iniciarSesion);
        TextView signup = findViewById(R.id.link_registrar);
        inputLayoutUserName = findViewById(R.id.input_layout_name);
        inputLayoutPassword = findViewById(R.id.input_layout_contrasena);

        password.setOnTouchListener(new View.OnTouchListener() {
            @Override
            public boolean onTouch(View v, MotionEvent event) {
                final int DRAWABLE_RIGHT = 2;

                if (event.getAction() == MotionEvent.ACTION_UP) {
                    if (event.getRawX() >= (password.getRight() - password.getCompoundDrawables()[DRAWABLE_RIGHT].getBounds().width())) {
                        if (password.getTransformationMethod() != null) { //No se muestra, quiero mostrarla
                            password.setTransformationMethod(null);
                            password.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_password, 0, R.drawable.ic_image_enabled, 0);

                        } else { //Se muestra, quiero ocultarla
                            password.setTransformationMethod(new PasswordTransformationMethod());
                            password.setCompoundDrawablesWithIntrinsicBounds(R.drawable.ic_password, 0, R.drawable.ic_image_disabled, 0);
                        }
                        return true;
                    }
                }
                return false;
            }
        });

        login.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                login.setEnabled(false);
                boolean canCallWS = true;

                if (userName.getText().toString().isEmpty()) {
                    inputLayoutUserName.setError("Debe introducir un nombre de usuario");
                    canCallWS = false;
                } else {
                    inputLayoutUserName.setErrorEnabled(false);
                }
                if (password.getText().toString().isEmpty()) {
                    inputLayoutPassword.setError("Debe introducir una contraseña");
                    canCallWS = false;
                } else {
                    inputLayoutPassword.setErrorEnabled(false);
                }

                //TODO: CHECK THIS IN THE FUTURE
                /*if(userName.getText().toString().equals("admin") && password.getText().toString().equals("admin")){
                    userLogged = new Usuario();
                    userLogged.setNombreUsuario("admin");
                    userLogged.setContrasena("admin");
                    goMapsActivity();
                }*/
                //Enviamos la petición
                if (canCallWS) {
                    callWebService();
                }

                login.setEnabled(true);
            }
        });

        signup.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentRegister = new Intent(LoginActivity.this, SignupActivity.class);
                LoginActivity.this.startActivity(intentRegister);

            }
        });

        //TODO: Fix Mock login.
        SharedPreferences sp1 = this.getSharedPreferences("login", MODE_PRIVATE);

        String unm = sp1.getString("username", null);
        String pass = sp1.getString("password", null);

        if (unm != null && pass != null && !unm.isEmpty() && !pass.isEmpty()) {
            Log.i("HOLA", "HOLA");

            userName.setEnabled(false);
            password.setEnabled(false);
            login.setEnabled(false);
            Log.i(TAG, "datos de usuario encontrados: " + unm + " " + pass);
            userLogged = new Usuario();
            userLogged.setNombreUsuario(unm);
            userLogged.setContrasena(pass);
            userName.setText(unm);
            password.setText(pass);


            callWebService();

        }
    }


    // Required permissions for the application.
    private boolean checkMapServices() {
        if (isServicesOK()) {
            return isMapsEnabled();
        }
        return false;
    }

    // Required permissions for the application.
    private void buildAlertMessageNoGps() {
        final AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setMessage("Esta aplicación requiere GPS para funcionar correctamente, ¿desea activarlo?")
                .setCancelable(false)
                .setPositiveButton("Si", new DialogInterface.OnClickListener() {
                    public void onClick(@SuppressWarnings("unused") final DialogInterface dialog, @SuppressWarnings("unused") final int id) {
                        Intent enableGpsIntent = new Intent(android.provider.Settings.ACTION_LOCATION_SOURCE_SETTINGS);
                        startActivityForResult(enableGpsIntent, PERMISSIONS_REQUEST_ENABLE_GPS);
                    }
                });
        final AlertDialog alert = builder.create();
        alert.show();
    }

    // Required permissions for the application.
    private boolean isMapsEnabled() {
        final LocationManager manager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);

        if (!manager.isProviderEnabled(LocationManager.GPS_PROVIDER)) {
            buildAlertMessageNoGps();
            return false;
        }
        return true;
    }

    // Required permissions for the application.
    private void getLocationPermission() {
        /*
         * Location of the device permission. Handled by a callback, onRequestPermissionsResult.
         */
        if (ContextCompat.checkSelfPermission(this.getApplicationContext(),
                android.Manifest.permission.ACCESS_FINE_LOCATION) == PackageManager.PERMISSION_GRANTED) {
            mLocationPermissionGranted = true;
            goMapsActivity();
        } else {
            ActivityCompat.requestPermissions(this, new String[]{
                            android.Manifest.permission.ACCESS_FINE_LOCATION},
                    PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION);
        }
    }

    public boolean isServicesOK() {
        Log.d(TAG, "isServicesOK: checking google services version");

        int available = GoogleApiAvailability.getInstance().isGooglePlayServicesAvailable(LoginActivity.this);

        if (available == ConnectionResult.SUCCESS) {
            //everything is fine and the user can make map requests
            Log.d(TAG, "isServicesOK: Google Play Services is working");
            return true;
        } else if (GoogleApiAvailability.getInstance().isUserResolvableError(available)) {
            //an error occured but we can resolve it
            Log.d(TAG, "isServicesOK: an error occured but we can fix it");
            Dialog dialog = GoogleApiAvailability.getInstance().getErrorDialog(LoginActivity.this, available, ERROR_DIALOG_REQUEST);
            dialog.show();
        } else {
            Toast.makeText(this, "No puedes realizar peticiones de mapa.", Toast.LENGTH_SHORT).show();
        }
        return false;
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String permissions[],
                                           @NonNull int[] grantResults) {
        mLocationPermissionGranted = false;
        switch (requestCode) {
            case PERMISSIONS_REQUEST_ACCESS_FINE_LOCATION: {
                // If request is cancelled, the result arrays are empty.
                if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
                    mLocationPermissionGranted = true;
                }
            }
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        Log.d(TAG, "onActivityResult: called.");
        switch (requestCode) {
            case PERMISSIONS_REQUEST_ENABLE_GPS: {
                if (mLocationPermissionGranted) {
                    //TODO: SOLVE THIS COMMENTED TEXT
                    goMapsActivity();
                } else {
                    getLocationPermission();
                }
            }
        }
    }

    // Call My Web Service
    private void callWebService() {
        final RequestQueue requestQueue = Volley.newRequestQueue(this);
        // subscribe
        token = "";

        FirebaseInstanceId.getInstance().getInstanceId()
                .addOnCompleteListener(new OnCompleteListener<InstanceIdResult>() {
                    @Override
                    public void onComplete(@NonNull Task<InstanceIdResult> task) {
                        if (!task.isSuccessful()) {
                            Log.w(TAG, "getInstanceId failed", task.getException());
                            return;
                        }

                        // Get new Instance ID token
                        token = task.getResult().getToken();

                        // Log and toast
                        Log.d("MyFirebaseMsgService", token);

                        String url = PROTOCOL + TWO_POINTS + DOUBLE_BAR + HOST + TWO_POINTS + PORT + BAR + "myplaces/log-in";

                        if (userName.getText().toString().length() == 0) {
                            inputLayoutUserName.setError("Debe introducir un nombre de usuario.");
                        } else if (password.getText().toString().length() == 0) {
                            inputLayoutPassword.setError("Debe introducir una contraseña.");
                        } else {
                            JSONObject jsonBody = new JSONObject();

                            try {

                                jsonBody = new JSONObject();
                                jsonBody.put("username", userName.getText().toString());
                                jsonBody.put("password", password.getText().toString());
                                jsonBody.put("myFirebaseToken", token);

                            } catch (JSONException e) {
                                e.printStackTrace();
                            }
                            JsonObjectRequest jsonObjectRequest = new JsonObjectRequest(Request.Method.POST, url,
                                    jsonBody, LoginActivity.this, LoginActivity.this);

                            requestQueue.add(jsonObjectRequest);
                        }

                    }
                });


    }

    // Error response listener
    @Override
    public void onErrorResponse(VolleyError error) {
        Toast.makeText(this, "No se ha podido iniciar sesión. Inténtelo de nuevo.", Toast.LENGTH_LONG).show();
        Log.i("ERROR", error.toString());
    }

    // Response listener
    @Override
    public void onResponse(JSONObject response) {
        userLogged = new Usuario();
        if (response != null)
            Log.i("La respuesta es: ", response.toString());
        CustomResponse customResponse = null;
        if (response != null) {
            customResponse = new CustomResponse(response.optString("status"),
                    response.optString("description"),
                    response.optString("message"),
                    response.optString("timeStamp"));
        } else {
            Toast.makeText(this, "No se ha podido iniciar sesión. Inténtelo de nuevo.", Toast.LENGTH_LONG).show();
        }

        if (customResponse != null) {
            if (customResponse.getStatus().equals(STATE_2xx) && customResponse.getDescription().equals(RESPONSE_OK) && customResponse.getMessage().toString().equals(LOGIN_OK)) {
                userLogged.setNombreUsuario(userName.getText().toString());
                userLogged.setContrasena(password.getText().toString());
                if (checkMapServices()) {
                    if (mLocationPermissionGranted) {
                        goMapsActivity();
                    } else {
                        getLocationPermission();
                    }
                }
            } else if (customResponse.getStatus().equals(STATE_2xx) && customResponse.getDescription().equals(RESPONSE_OK) && customResponse.getMessage().toString().equals(LOGIN_KO)) {
                Toast.makeText(this, "Nombre de usuario y/o contraseña incorrectos.", Toast.LENGTH_LONG).show();
                inputLayoutUserName.setError("Debe introducir un nombre de usuario correcto.");
                inputLayoutPassword.setError("Debe introducir una contraseña correcto.");
            }
        } else {
            Toast.makeText(this, "No se ha podido iniciar sesión. Inténtelo de nuevo.", Toast.LENGTH_LONG).show();
        }
    }

    private void goMapsActivity() {
        Handler handler = new Handler();

        ProgressDialog.show(LoginActivity.this, "Iniciando sesión", "Cargando...");

        SharedPreferences sp = getSharedPreferences("login", MODE_PRIVATE);
        SharedPreferences.Editor Ed = sp.edit();
        Ed.putString("username", userLogged.getNombreUsuario());
        Ed.putString("password", userLogged.getContrasena());
        Ed.commit();

        handler.postDelayed(new Runnable() {
            public void run() {
                Intent intentRegister = new Intent(LoginActivity.this, CoreMapActivity.class);
                intentRegister.putExtra("user", userLogged);

                LoginActivity.this.startActivity(intentRegister);
            }
        }, 2000);
    }



    @Override
    public void onBackPressed() {

        //Do nothing
    }

}
