package com.juablaz.myplaces.Util;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.TextView;

import com.example.juancarlos.myplaces.R;
import com.google.android.gms.maps.GoogleMap;
import com.google.android.gms.maps.model.Marker;

public class CustomInfoWindowAdapter implements GoogleMap.InfoWindowAdapter {

    private final View mWindow;

    public CustomInfoWindowAdapter(Context context) {
        mWindow = LayoutInflater.from(context).inflate(R.layout.marker_info_window, null);
    }

    private void renderWindowText(Marker marker, View view) {
        String title = marker.getTitle();
        TextView tvTitle = view.findViewById(R.id.info_window_titulo);
        if (!tvTitle.toString().equals("")) {
            tvTitle.setText(title);
        }

        String snippet = marker.getSnippet();

        TextView tvSnippet = view.findViewById(R.id.info_window_descripcion);
        if (!tvSnippet.toString().equals("")) {
            tvSnippet.setText(snippet);
        }

    }

    @Override
    public View getInfoContents(Marker marker) {
        renderWindowText(marker, mWindow);
        return mWindow;
    }

    @Override
    public View getInfoWindow(Marker marker) {
        renderWindowText(marker, mWindow);
        return mWindow;
    }

}