package com.juablaz.myplaces.Util;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import static com.juablaz.myplaces.Util.StringUtils.DATE_DATABASE_FORMAT;

public class DateUtils {

    public static String formatDateToUserStr(Date date) {
        String fecha;
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        String yearStr;
        String monthStr;
        String dayStr;
        String hourStr;
        String minuteStr;
        String secondStr;

        int year = cal.get(Calendar.YEAR);
        int month = cal.get(Calendar.MONTH)+1;
        int day = cal.get(Calendar.DAY_OF_MONTH);

        int hour = cal.get(Calendar.HOUR_OF_DAY);
        int minute = cal.get(Calendar.MINUTE);
        int second = cal.get(Calendar.SECOND);

        if (day < 10) {
            dayStr = "0" + day;
        } else {
            dayStr = day + "";
        }
        if (month < 10) {
            monthStr = "0" + month;
        } else {
            monthStr = month + "";
        }
        if (hour < 10) {
            hourStr = "0" + hour;
        } else {
            hourStr = hour + "";
        }
        if (minute < 10) {
            minuteStr = "0" + minute;
        } else {
            minuteStr = minute + "";
        }
        if (second < 10) {
            secondStr = "0" + second;
        } else {
            secondStr = second + "";
        }

        yearStr = year + "";

        fecha = dayStr + "-" + monthStr + "-" + yearStr + " " + hourStr + ":" + minuteStr + ":" + secondStr;

        return fecha;
    }

    public static Date formatToDateUser(String str) {
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_DATABASE_FORMAT);
        Date fecha = new Date();
        try {
            fecha = sdf.parse(str);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return fecha;
    }
}
