package com.juablaz.myplaces.Util;

import android.content.Context;
import android.graphics.Color;
import android.support.v4.content.ContextCompat;
import android.text.Editable;
import android.text.TextWatcher;
import android.widget.EditText;
import android.widget.TextView;

import com.example.juancarlos.myplaces.R;

import static com.juablaz.myplaces.Util.StringUtils.COLOR_GREEN;

public class EditTextLinesLimiter implements TextWatcher {
    private final int MAX_LINES = 10;
    private final int LETTERS_YELLOW = 4;

    private EditText editText;
    private int maxLines;
    private String lastValue = "";
    private TextView textCountSnippet;
    private Context context;
    private String option;

    public EditTextLinesLimiter(EditText editText, int maxLines, String option) {
        this.editText = editText;
        this.maxLines = maxLines;
        this.option = option;
    }

    public EditTextLinesLimiter(Context context, EditText editText, int maxLines, TextView textCountSnippet, String option) {
        this.editText = editText;
        this.maxLines = maxLines;
        this.textCountSnippet = textCountSnippet;
        this.context = context;
        this.option = option;

        //Limite de caracteres
        textCountSnippet.setText(Integer.toString(MAX_LINES) + " Líneas");
        textCountSnippet.setTextColor(COLOR_GREEN);
    }

    @Override
    public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
        lastValue = charSequence.toString();
    }

    @Override
    public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

    }

    @Override
    public void afterTextChanged(Editable editable) {
        if (editText.getLineCount() > maxLines) {
            int selectionStart = editText.getSelectionStart() - 1;
            editText.setText(lastValue);
            if (selectionStart >= editText.length()) {
                selectionStart = editText.length();
            }
            editText.setSelection(selectionStart);
        }

        if (option.equals("snippet")) {
            int count = MAX_LINES - editText.getLineCount();
            if (editText.getText().toString().isEmpty()) {
                count = MAX_LINES;
            }
            if (count == 1) {
                textCountSnippet.setText(Integer.toString(count) + " Línea");
            } else {
                textCountSnippet.setText(Integer.toString(count) + " Líneas");
            }
            textCountSnippet.setTextColor(COLOR_GREEN);
            if (count < LETTERS_YELLOW)
                textCountSnippet.setTextColor(ContextCompat.getColor(context, R.color.colorOrange));
            if (count <= 0)
                textCountSnippet.setTextColor(Color.RED);
        }
    }
}