package com.juablaz.myplaces;

import android.app.Activity;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.example.juancarlos.myplaces.R;

public class ViewPlaceActivity extends Activity {
    private Boolean isNotification;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_view_place);

        final TextView title = findViewById(R.id.input_title);
        final TextView snippet = findViewById(R.id.input_descripcion);

        final String titleText = getIntent().getStringExtra("title");
        final double currentLocationLongitude = getIntent().getDoubleExtra("currentLocationLongitude", 0);
        final double currentLocationLatitude = getIntent().getDoubleExtra("currentLocationLatitude", 0);
        isNotification = getIntent().getBooleanExtra("isNotification", true);
        final String snippetText = getIntent().getStringExtra("snippet");

        Log.i("TAG", currentLocationLatitude + " , " + currentLocationLongitude);

        Button boton_irA = findViewById(R.id.go_maps);

        title.setText(titleText);
        if (snippetText.split("Dirección: ")[0].isEmpty()) {
            snippet.setText(Html.fromHtml("<b>" + "Dirección: " + "</b>"
                    + snippetText.split("Dirección: ")[1]));
        } else {
            snippet.setText(Html.fromHtml(snippetText.split("Dirección: ")[0].replaceAll("\n", "<br>") + "<b><br><br>" + "Dirección: " + "</b>"
                    + snippetText.split("Dirección: ")[1]));
        }

        boton_irA.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(final View view) {
                String map = "http://maps.google.com/maps?daddr=" + snippetText.split("Dirección: ")[1].replaceAll("\n", "") + "&saddr=" + currentLocationLatitude + "," + currentLocationLongitude;
                Intent intent = new Intent(Intent.ACTION_VIEW, Uri.parse(map));
                startActivity(intent);

            }
        });
    }

    @Override
    public void onBackPressed() {
        if (isNotification) {
            Intent intentRegister = new Intent(ViewPlaceActivity.this, CoreMapActivity.class);

            ViewPlaceActivity.this.startActivity(intentRegister);
        } else {
            super.onBackPressed();
        }
    }

}